﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate;
using Dnad09.Blog.Consultas.DTOs;

namespace Dnad09.Blog.Consultas
{
    public class ConsultaPostagem : ConsultaBase
    {
        public ConsultaPostagem(ISession session) : base(session) { }

        public IList<TotalDeComentariosEmUmaPostagem> ObterPostagensComTotalDeComentarios(
            string autor,
            int pagina)
        {
            var textoConsulta = @"select new TotalDeComentariosEmUmaPostagem(p.Id, p.Titulo, count(c)) from Postagem p left outer join p.Comentarios c Group By p.Id, p.Titulo, p.Autor ";

            if (!string.IsNullOrEmpty(autor))
            {
                textoConsulta += " Having p.Autor = :autor";
            }
            var consulta = this.Session.CreateQuery(textoConsulta);
            if (!string.IsNullOrEmpty(autor))
            {
                consulta.SetString("autor", autor);
            }
            if (pagina != 0)
            {
                consulta.SetFirstResult(10 * (pagina - 1));
                consulta.SetMaxResults(10);
            }
            var postagens = consulta.List<TotalDeComentariosEmUmaPostagem>();
            return postagens;
        }       

    }
}
