﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FluentNHibernate.Cfg;
using NHibernate;
using Dnad09.Blog.Dominio;
using FluentNHibernate.AutoMap;
using FluentNHibernate.Conventions.Helpers;
using Dnad09.Blog.Dominio.Entidades;
using NHibernate.Tool.hbm2ddl;

namespace Dnad09.Blog.Repositorio.Config
{
    public class Autoconfiguracao
    {
        private static ISessionFactory _factory;
        public static ISessionFactory Configurar(bool gerarBanco = true)
        {
            if (_factory != null)
                return _factory;

            //var config = Fluently.Configure()
            //    .Database(
            //    FluentNHibernate.Cfg.Db.SQLiteConfiguration.Standard
            //    .ConnectionString(c => c.Is("data source=:memory:"))
            //    .ShowSql());


            var config = Fluently.Configure()
                .Database(
                FluentNHibernate.Cfg.Db.MsSqlConfiguration.MsSql2005
                .ConnectionString(c =>
                  c.Is(@"Data Source=.\sqlexpress;Initial Catalog=DNAD09Blog;Integrated Security=True"))
                  .ShowSql()
            );
            config.Mappings(m =>
            {
                m.HbmMappings.AddFromAssemblyOf<Autoconfiguracao>();

                m.FluentMappings
                    .AddFromAssemblyOf<Autoconfiguracao>();

                m.AutoMappings.Add(
                    AutoPersistenceModel.MapEntitiesFromAssemblyOf<Postagem>()
                    .WithSetup(s => s.IsBaseType = (type => type == typeof(EntidadeComId)))
                    .ConventionDiscovery.Setup(c =>
                    {
                        c.Add(PrimaryKey.Name.Is(x => x.EntityType.Name + "_Id"));
                        c.Add(DefaultLazy.AlwaysFalse());
                        //c.Add(ForeignKey.Format((prop, tipo) => prop.Name + "_Id"));
                        c.Add(Table.Is(x => x.EntityType.Name));
                    }
                    )
                    .Where(t =>
                        t.Namespace == "Dnad09.Blog.Dominio.Entidades"
                        && t.IsInterface == false
                        && t.IsAbstract == false
                    )
                );
            }
            );

            if (gerarBanco)
            {
                config.ExposeConfiguration(cfg =>
                {
                    var schemaExport = new SchemaExport(cfg);
                    schemaExport.Create(false, true);
                    //schemaExport.Execute(true, true, false, true, _factory.OpenSession().Connection, Console.Out);
                });
            }

            _factory = config.BuildSessionFactory();
            return _factory;
        }

        

       



    }
}
