﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using Dnad09.Blog.Repositorio;
using Dnad09.Blog.Repositorio.Config;
using Dnad09.Blog.Dominio.Entidades;

namespace Dnad09.Blog.WebApp.Controllers
{
    public class UsuariosController : Controller
    {

        private readonly RepositorioUsuario _repositorio;
        public UsuariosController()
        {
            var fabricaSessao = Autoconfiguracao.Configurar();
            var sessao = fabricaSessao.OpenSession();
            _repositorio = new RepositorioUsuario(sessao);
        }
        //
        // GET: /Usuarios/

        public ActionResult Index()
        {
            var usuarios = _repositorio.ObterTodos();
            return View(usuarios);
        }

        //
        // GET: /Usuarios/Details/5

        public ActionResult Details(int id)
        {
            return View();
        }

        //
        // GET: /Usuarios/Create

        public ActionResult Create()
        {
            return View(new Usuario());
        } 

        //
        // POST: /Usuarios/Create

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Create(Usuario usuario)
        {
            try
            {
                _repositorio.Salvar(usuario);

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        //
        // GET: /Usuarios/Edit/5
 
        public ActionResult Edit(int id)
        {
            return View();
        }

        //
        // POST: /Usuarios/Edit/5

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Edit(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here
 
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }
    }
}
